############################################################
#                       AUTH-LIB.PL
#
# Dieses Script wurde von Selena Sol & Gunther Birznieks geschrieben. 
# Urspruengliche Programmierung:	10.05.96
# Letzte Aenderung:			14.05.96
# Deutsche Uebersetzung: Gerold Bigorajski
#
#   Es darf unter den Bedingungen der GNU General Public
#   License oder der Artistic License, die zusammen mit
#   Perl v5.x fr UNIX verteilt wird, kopiert werden.
# 
# Selena Sol kann unter selena@eff.org kontaktiert werden.
# Gerold Bigorajski ist unter bigorajski@t-online.de erreichbar.
#
# Zweck: Es stellt einen Satz an Bibliotheksroutinen zur Verfuegung,
# um eine standardiesierte Benutzeroberflaeche zur Authentiserung
# bei cgi-Programmen zu liefern.
#
# Hauptprozeduren:
#   GetSessionInfo - Gibt die Sitzungsinformationen zurck oder
#   bittet den Benutzer um ein Login.
#
# Besondere Anmerkung: Dieses Script benutzt zum Versenden von
# emails mail-lib.pl (falls dies aktiviert ist).
#
# Es verwendet ebenfalls CRYPT innerhalb der EncrytWrap-Routine.
# Wenn Ihr Betriebssystem Crypt nicht unterstuetzt, koennen Sie Ihre
# eigene EncryptWrap-Routine schreiben. Die Routine sitzt in der
# Bibliothek auth-extra-lib.pl.
#
# Das Script ist kompakt dafuer geschrieben, Sitzungsinformationen
# zurueckzugeben, weil es dies in 99% aller Faelle tut. Wenn weitere
# Aktionen von ihm velangt werden, schickt es ein require-Statement 
# an eine grosse Datei namens auth-extra-lib.pl, die alle moeglichen
# Subroutinen und Optionen enthaelt.
#
# Die Umgebungsvariablen, die die Authetisierungs-Bibliothek setzen
# soll, sind die folgenden:
#
#  Diese Variablen sollten in der Sektion zur Variablendefinition
#  eines jeden Programmes definiert werden, dass auf diese Authenti-
#  sierungsroutienen zugreift.
#
#  Pfad zu den Authentiserungsbibliotheken.
#$auth_lib = ".";
#  Findet server-basierte Authentisierung statt?
#$auth_server = "off";
#  Findet CGI-baiserte Authentisierung statt? D.h., findet das
#  Login mittels eines CGI-Formulares statt?
#$auth_cgi = "on";
#
#  ANMERKUNG: Wenn weder CGI- noch Server-Authentiserung auf "ON" stehen,
#  gibt das Programm eine Sitzungs-ID mit leeren Inforamtionen in den Feldern,
#  nach denen das Programm Ausschau haelt, zurueck.
#
#  Wo ist die Benutzerdatei gespeichert?
#$auth_user_file = "user.dat";
#  Falls alt_user_file definiert ist, werden die Informationen eines
#  Benutzers bei der Registrierung in die alternative Benutzerdatei
#  eingetragen, bis der System-Administrator sie hinberkopiert.
#  Normalerweise findet die Registierung einfach in der Hauptdatei statt.
#$auth_alt_user_file = "altuser.dat";
#
#  Auth_allow_register schaltet die Option ein, dass der Benutzer sich
#  registrieren darf
#$auth_allow_register = "on";
#
#  Auth_allow_search schaltet die Option ein, dass der Benutzer die
#  Benutzerliste nach seinem Namen durchsuchen darf, falls er ihn
#  vergessen hat.
#$auth_allow_search = "on";
#
#  Die Standardgruppe ist der Standardname der Gruppenvariablen in der
#  Benutzerdatei, wenn ein Benutzer hinzugefgt wird. Gruppen sind sinnvoll,
#  um Rechte in einem Programm zu definieren, z.B. Ausloesung bestimmter
#  Ereignisse.
#$auth_default_group = "normal";
#
#  Wenn auth_check_duplicates auf "on" steht, ueberprueft das Programm auf
#  doppelte Benutzernamen, wenn eine Person sich registrieren will. Sowohl
#  in der Standard- als auch in der alternativen Benutzerdatei (siehe oben)
#  wird auf Duplikate ueberprueft.
#$auth_check_duplicates = "on";
#
#  Wenn auth_generate_password auf "on" steht, erzeugt das Programm ein
#  Kennwort fuer den Benutzer.
#$auth_generate_password = "on";
#
#  Wenn add_register auf "on" steht, sichert das Programm die Benutzer-
#  registration in die Standard- oder alternative Benutzerdatei, abhaengig
#  von den oben gesetzten Einstellungen.
#$auth_add_register = "on";
#
#  Wenn email-register auf "on" steht, schickt das Programm dem Systemadministrator
#  ein email ueber die Registrierung.
#$auth_email_register = "on";
#
#  Absender-Adresse. Dies muss eine gueltige Adresse auf der Maschine sein, auf der
#  sich der Webserver befindet. ("\" vor dem Klammeraffen nicht vergessen!)
#$auth_admin_from_address = "webmaster\@ihre_domain.de";
#
#  Empfaenger-Adresse fuer die Registrierungs-Information.
#$auth_admin_email_address = "ich\@mein_provider.de";
#
#  Sitzungs-Dateien sollten aufgehoben werden, bis der Benutzer nicht laenger mit
#  derselben ID zurueckkommen muss. Die Anzahl wird in Tagen gemessen. Zwei Tage
#  ist in aller Regel mehr als ausreichend.
#$auth_session_length = 2;
#
#  session_dir ist das Unterverzeichnis, in dem die Sitzungen gespeichert sind.
#$auth_session_dir = "./Sessions";
#
#  register_message ist die Mitteilung, die der Benutzer nach erfolgreicher
#  Registrierung zu sehen bekommt. Dies sollte geaendert werden, wenn die
#  Benutzerinformationen nicht direkt in der Hauptbenutzerdatei gespeichert werden.
#$auth_register_message =
#	"Vielen Dank. Sie knnen sich nun mit Ihrem neuen Benutzernamen und Kennwort einloggen.";
#
#  Auth_password_message ist eine zum Benutzer geschickte Mitteilung, wenn er
#  sich bewirbt und ihm sein Kennwort uebermittelt werden muss. Der letzte Teil
#  der Mitteilung ist das Kennwort selbst, welches bei der Registrierung vom
#  Programm an die Mitteilung angehaengt wird.
#$auth_password_message =
#  "Vielen Dank fr die Registrierung auf unsere Site! Ihr Kennwort ist";
#
#  Auth_extra_fields ist ein Array, das die Namen jeglicher Felder enthaelt, die
#  ueber den Nutzer gespeichert werden - ausser Benutzername, Kennwort und Gruppe.
# 
#  Beachten Sie, dass ALLE zusaetzlichen Felder den Begriff "auth" enthalten muessen.
#
#  Beachten Sie auch, dass es ein Feld namens auth_email geben muss, damit die Suchfunktion
#  in dem Programm funktioniert.
# 
#@auth_extra_fields = ("auth_first_name", "auth_last_name", "auth_email");
#
#  Auth_extra_desc sind die beschreibenden Feldnamen, die zu den entsprechenden
#  Elementen in auth_extra_fields gehoeren.
#
#@auth_extra_desc = ("First Name", "Last Name", "Email");
#
#  bodytag und separaturl sind allen HTML-Ausageben gemeinsame Elemente.
#  bodytag enthaelt den vollstaendigen Bodytag (falls die Site ein
#  gemeinsames Design verwendet, sonst einfach <body>.
#  separaturl gibt die URL eines Trennbildes an. Ansonsnten wird
#  einfach <hr> dafuer eingesetzt.
#  Bitte beachten, dass Anfuehrungsstriche usw. mit dem Backslash
#  maskiert sein muessen!
############################################################


$bodytag    = "<body background=\"http://www.gb-direkt.de/_themes/sumipntg/sumtextb.jpg\" bgcolor=\"\#FFFFFF\" text=\"\#808080\" link=\"\#3333CC\" vlink=\"\#666699\" alink=\"\#990099\"><font face=\"verdana, arial, helvetica\">\n";
$separaturl = "http://www.gb-direkt.de/_themes/sumipntg/sumhorsa.gif";

if($bodytag eq "")
{
	$bodytag = "<body>\n";
}
if($separaturl eq "")
{
	$separatimg = "<hr>\n";
}
else
{
	$separatimg = "<p align=\"center\"><img src=\"$separaturl\" width=\"300\" height=\"10\"></p>";
}

############################################################
#
# Subroutine: GetSessionInfo 
#   Verwendung:
#   ($session, $username, $group, @extra_fields,
#    = &GetSessionInfo($session, "script name", *in);
#
#   Parameter:
#     $session = Sitzungs-ID. Null, falls sie noch nicht definiert ist.
#     $main_script = Das Script, von dem aus &GetSessionInfo aufgerufen wird.
#     *in = Ein Verweis auf die Formulardaten, die mit &ReadParse gelesen wurden.
#
#   Ausgabe:
#     $session = Sitzungs-ID
#     $username = Benutzername
#     $group = Gruppeninformation
#     @extra_fields = Ein Array zusaetzlicher Felder; i.d.R. mit folgendem Inhalt:
#       $vorname  = Vorname
#       $nachname = Nachname
#       $email    = email-Adresse
############################################################

sub GetSessionInfo
{
	local($session, $main_script, *in) = @_;
	local($session_file, @fields);
	local(@fields);

	# Wenn die Sitzung nicht definiert ist, werden alle Routinen geladen und dann
	# die Subroutine VerifyUser aufgerufen, die das Login fuer die Person bewirkt.
	#
	# Wenn die Sitzungs-ID definiert ist, wird einfach die Sitzungs-ID gelesen und
	# die Information an das mit der Sitzung verbundene Programm zurueckgegeben.

	if ($session eq "")
	{
		require "$auth_lib/auth-extra-lib.pl";
		@fields = &VerifyUser($main_script, *in);
	} # Ende der Abfrage if($session eq "")
	else
	{
		$session_file = "$session.dat";
		open (SESSIONFILE, "$auth_session_dir/$session_file") || 
			(require "$auth_lib/auth-lib-fail-html.pl" && exit);

		while (<SESSIONFILE>)
		{
			@fields = split(/\|/);
		}
		close (SESSIONFILE);

		unshift(@fields, $session);
	} # Ende des else-Zweiges

	# Rueckgabe des Feld-Arrays:

	@fields;

} # End e der Subroutine GetSessionInfo

1;
