#!/usr/bin/perl

###########################################################################
#                              cgi-lib.sol
#
#
# Dieses Script wurde von Selena Sol geschrieben. 
#
#   Es darf unter den Bedingungen der GNU General Public
#   License oder der Artistic License, die zusammen mit
#   Perl v5.x fr UNIX verteilt wird, kopiert werden.
# 
# Selena Sol kann unter selena@eff.org kontaktiert werden.
# Gerold Bigorajski ist unter bigorajski@t-online.de erreichbar.
#
###########################################################################


###########################################################################
#                                 counter                                 #
###########################################################################

sub counter
{
	# Der lokalen Variablen $counter_file wird der Dateiname zugewiesen,
	# der der Subroutine vom Hauptscript uebergeben wurde.

	local($counter_file) = @_;

	# Oeffnen der Zaehlerdatei. Falls es dabei einen Fehler gibt, erfolgt
	# Zugriff auf die Routine &open_error, an die der Dateiname uebergeben
	# wird.

	open (COUNTER_FILE, "$counter_file") || &open_error($counter_file);

	# Einlesen der aktuellen Zaehlernummer und Uebergabe an $_

	while (<COUNTER_FILE>)
	{
		$item_number = "$_";
	}
	close (COUNTER_FILE);

	# Inkrementieren der Nummer, Rueckschreiben der zaehlerdatei mit der neuen
	# Nummer, Uebergabe der Nummer an das Hauptscript, Schliessen der
	# Zahelerdatei.

	$item_number += 1;
	open (NOTE, ">$counter_file") || &open_error($counter_file);
	print NOTE "$item_number\n";
	close (NOTE);
	return $item_number;
}

###########################################################################
#                               open_error                                #
###########################################################################

sub open_error
{
	# Der lokalen Variablen $file_name wird der Dateiname zugewiesen, den
	# diese Routine von der aufrufenden Subroutine uebergeben bekommen hat.

	local ($filename) = @_;

	# Der Benutzer bekommt eine Meldung, dass das Script die verlangte Datei
	# nicht oeffnen konnte und die routine abbricht.

	print "Leider konnte die Datei<P align=center><strong>$filename</strong><P> 
	nicht geffnet werden. Bitte stellen Sie sicher, dass der Dateiname in der
	Setup-Datei define_variables.pl korrekt definiert ist, dass die Datei 
	tatschlich existiert und der Server darauf Zugriff hat. Vielen Dank!";
	die;
}

###########################################################################
#                               header_tags                               #
###########################################################################

sub header_tags
{
	local ($title) = @_;
	$header_tags = "<HTML>\n<HEAD>\n<TITLE>$title</TITLE>\n</HEAD>\n";
	return $header_tags;
}

###########################################################################
#                           table_header                                  #
###########################################################################

sub table_header
{
	# Der lokalen Variablen $file_name wird der Dateiname zugewiesen, den
	# diese Routine von der aufrufenden Subroutine uebergeben bekommen hat.

	local (@headings) = @_;
	local ($table_header);

	# Nun werden die HTML-Argumente in die Variable $table_tag geschrieben.

	foreach $table_field (@headings)
	{
		$table_header .= "<TH>$table_field</TH>\n";
      }
	$table_header .= "\n";
	return $table_header;
}

###########################################################################
#                           select_tag                                    #
###########################################################################

sub select_tag
{
	# Der lokalen Variablen $file_name wird der Dateiname zugewiesen, den
	# diese Routine von der aufrufenden Subroutine uebergeben bekommen hat.

	local ($name, $size, $multiple) = @_;
	local ($select_tag, $select_argument);
	local (@select_arguments, @select_values, %SELECT_ARGUMENTS);
	%SELECT_ARGUMENTS = ("NAME", "$name", "SIZE", "$size", "MULTIPLE", "$multiple");
	@select_arguments = keys %SELECT_ARGUMENTS;
	@select_values = values %SELECT_ARGUMENTS;
	$select_tag = "";
	$select_argument = "";

	# Nun werden die HTML-Argumente in die Variable $table_tag geschrieben.

	$select_tag .= "<SELECT ";
	foreach $select_argument (@select_arguments)
	{
		if ($select_argument eq "multiple")
		{
			$select_tag .= "MULTIPLE ";
		}    
		elsif ($SELECT_ARGUMENTS{$select_argument} ne "")
		{
			$select_tag .= "$select_argument = \"$SELECT_ARGUMENTS{$select_argument}\" ";
		}
	}
	$select_tag .= ">\n";
	return $select_tag;
}

###########################################################################
#                        select_options                                   #
###########################################################################

sub select_options
{
	# Der lokalen Variablen $file_name wird der Dateiname zugewiesen, den
	# diese Routine von der aufrufenden Subroutine uebergeben bekommen hat.

	local (@select_options) = @_;
	local ($select_options);
	$select_options = "";

	# Hinzufuegen der kategorien, die von der aufrufenden Routine in dem
	# Auswahlkaestchen uebergeben wurde. Dabei wird sichergestellt, dass
	# die erste kategorie gewaehlt wird.

	foreach $option (@select_options)
	{
		$select_options .= "<OPTION>$option</OPTION>\n";
	}

	# Vervollstaendigen des HTML-Codes fuer die Auswahltabelle und
	# Rueckgabe der Variable, die von der hauptroutine gedruckt werden
	# soll.

	$select_options .= "</SELECT>\n";
	return $select_options;
}

###########################################################################
#                         build_input_form                                #
###########################################################################

sub build_input_form
{
	# Der lokalen Variablen $file_name wird der Dateiname zugewiesen, den
	# diese Routine von der aufrufenden Subroutine uebergeben bekommen hat.

	local ($variable_name, $form_type, $field_name) = @_;
	local ($input_form);
	$input_form = "";

	$input_form .= "<TR>\n";
	$input_form .= &table_header ("$field_name");
	$input_form .= "<TD>";
	$input_form .= &make_form_row ("$field_name", "$variable_name", "$form_type");
	$input_form .= "</TD></TR>\n";
	return $input_form;
}

###########################################################################
#                           make_form_row                                 #
###########################################################################

sub make_form_row
{
	# Der lokalen Variablen $file_name wird der Dateiname zugewiesen, den
	# diese Routine von der aufrufenden Subroutine uebergeben bekommen hat.

	local ($name, $variable_name, $type) = @_;
	local (@options_and_arguments);
	@options_and_arguments = ();
	($type, @options_and_arguments) = split(/\|/, $type);
	local ($form_row);
	$form_row = "";

	if ($type eq "text")
	{
		$form_row .= "<INPUT TYPE = \"text\" NAME = \"$variable_name\" ";
		foreach $argument (@options_and_arguments)
		{
			$form_row .= "$argument ";
		}
		$form_row .= ">";
	}

	if ($type eq "textarea")
	{
		$form_row .= "<TEXTAREA NAME = \"$variable_name\" "; 
		foreach $argument (@options_and_arguments)
		{
			$form_row .= "$argument ";
		}
		$form_row .= "></TEXTAREA>";
	}

	if ($type eq "invisible")
	{
		$form_row .= "$item_number";
	}

	if ($type eq "select")
	{
		$number = shift (@options_and_arguments);
		$multiple = shift (@options_and_arguments);
		$form_row .= &select_tag("$variable_name", "$number");
          
		$form_row .= &select_options(@options_and_arguments);
		$form_row .= "</SELECT>";
	}
	return $form_row;
}

###########################################################################
#                      get_database_rows                                  #
###########################################################################

sub get_database_rows
{
	local ($datafile, @keywords) = @_;
	open (DATABASE, "$datafile");
	while (<DATABASE>)
	{
		unless ($_ =~ /^COMMENT:/)
		{
			push (@database_rows, $_);
		}
	}
	@database_rows;
	close (DATABASE);
}

###########################################################################
#                           table_rows                                    #
###########################################################################

sub table_rows
{
	# Der lokalen Variablen $file_name wird der Dateiname zugewiesen, den
	# diese Routine von der aufrufenden Subroutine uebergeben bekommen hat.

	local (@row) = @_;
	local ($table_cell);

	# Nun werden die HTML-Argumente in die Variable $table_tag geschrieben.

	foreach $table_field (@row)
	{
		$table_field =~ s/~~/\|/g;
		$table_cell .= "<TD>$table_field</TD>\n";
	}
	$table_cell .= "\n";
	return $table_cell;
}

#######################################################################
#                            GetFileLock                              #
#######################################################################

sub GetFileLock
{  
	local ($lock_file) = @_;

	local ($endtime);  
	$endtime = 60;
	$endtime = time + $endtime;
	#  60 Sekunden wird gewartet - sonst muss ein anderer Fehler vorliegen.

	while (-e $lock_file && time < $endtime)
	{
		# Eine Sekunde warten
		sleep(1);
	}
	open(LOCK_FILE, ">$lock_file");    
	# flock(LOCK_FILE, 2); # 2 sperrt die Datei fuer exklusiven Zugriff
} # Ende der Subroutine get_file_lock

#######################################################################
#                            ReleaseFileLock                          #
#######################################################################

sub ReleaseFileLock
{
	local ($lock_file) = @_;
       
	# 8 entsperrt die Datei
	# flock(LOCK_FILE, 8);
	close(LOCK_FILE);
	unlink($lock_file);

} # Ende der Subroutine ReleaseFileLock   

#######################################################################
#                            EncryptWrap                              #
#######################################################################

sub EncryptWrap
{
	local ($field, $salt) = @_;
 
	$field = crypt ($field, $salt);
 
	$field;
 
} # Ende der Subroutine EncryptWrap

1;
