package date;

# Das folgende definiert den ersten Tag der Benutzung des Gregorianischen Kalenders
# im englischen Knigreich (14. September 1752). Der vorhergehende Tag war der 2. 
# September 1752 nach dem Julianischen Kalender. Zuvor begann das Jahr am 25. Maerz.

$brit_jd = 2361222;

sub main'jdate
# Verwendung:  ($month,$day,$year,$weekday) = &jdate($julian_day)
{
	local($jd) = @_;
	local($jdate_tmp);
	local($m,$d,$y,$wkday);

	warn("Warnung:  Vor dem Datum der ersten britischen Verwendung des Gregoriansichen Kalenders\n") if ($jd < $brit_jd);

	$wkday = ($jd + 1) % 7;       # Arbeitstage berechnen (0=Sonntag, 6=Samstag)
	$jdate_tmp = $jd - 1721119;
	$y = int((4 * $jdate_tmp - 1)/146097);
	$jdate_tmp = 4 * $jdate_tmp - 1 - 146097 * $y;
	$d = int($jdate_tmp/4);
	$jdate_tmp = int((4 * $d + 3)/1461);
	$d = 4 * $d + 3 - 1461 * $jdate_tmp;
	$d = int(($d + 4)/4);
	$m = int((5 * $d - 3)/153);
	$d = 5 * $d - 3 - 153 * $m;
	$d = int(($d + 5) / 5);
	$y = 100 * $y + $jdate_tmp;
	if($m < 10)
	{
		$m += 3;
	}
	else
	{
		$m -= 9;
		++$y;
	}
	($m, $d, $y, $wkday);
}


sub main'jday
# Verwendung:  $julian_day = &jday($month,$day,$year)
{
	local($m,$d,$y) = @_;
	local($ya,$c);

	$y = (localtime(time))[5] + 1900  if ($y eq '');

	if ($m > 2)
	{
		$m -= 3;
	}
	else
	{
		$m += 9;
		--$y;
	}
	$c = int($y/100);
	$ya = $y - (100 * $c);
	$jd =  int((146097 * $c) / 4) +
		 int((1461 * $ya) / 4) +
		 int((153 * $m + 2) / 5) +
		 $d + 1721119;
	warn("Warnung:  Vor dem Datum der ersten britischen Verwendung des Gregorianischen Kalenders\n")
		if ($jd < $brit_jd);
	$jd;
}

sub main'is_jday
{
# Verwendung:  if (&is_jday($number)) { print "yep - looks like a jday"; }
	local($is_jday) = 0;
	$is_jday = 1 if ($_[0] > 1721119);
}

sub main'monthname
# Verwendung:  $month_name = &monthname($month_no)
{
	local($n,$m) = @_;
	local(@names) = ('Januar','Februar','Mrz','April','Mai','Juni',
	                 'Juli','August','September','Oktober','November',
	                 'Dezember');
	if ($m ne '')
	{
		substr($names[$n-1],0,$m);
	}
	else
	{
		$names[$n-1];
	}
}

sub main'monthnum
# Verwendung:  $month_number = &monthnum($month_name)
{
	local($name) = @_;
	local(%names) = (
		'JAN',1,'FEB',2,'MAR',3,'APR',4,'MAY',5,'JUN',6,'JUL',7,'AUG',8,
		'SEP',9,'OCT',10,'NOV',11,'DEC',12);
	$name =~ tr/a-z/A-Z/;
	$name = substr($name,0,3);
	$names{$name};
}

sub main'weekday
# Verwendung:  $weekday_name = &weekday($weekday_number)
{
	local($wd) = @_;
	("Sonntag","Montag","Dienstag","Mittwoch","Donnerstag","Freitag","Samstag")[$wd];
}

sub main'today
# Verwendung:  $today_julian_day = &today()
{
	local(@today) = localtime(time);
	local($d) = $today[3];
	local($m) = $today[4];
	local($y) = $today[5];
	$m += 1;
	$y += 1900;
	&main'jday($m,$d,$y);
}
	
sub main'yesterday
# Verwendung:  $yesterday_julian_day = &yesterday()
{
	&main'today() - 1;
}
	
sub main'tomorrow
# Usage:  $tomorrow_julian_day = &tomorrow()
{
	&main'today() + 1;
}
	
