#!/usr/bin/perl
#
# dcadmin97.cgi
# Part of DCForum97 by DCScripts
# Written By David S. Choi, dc@sitedeveloper.com
# 10 August 1997
#
# Copyright  1997 DCScripts All Rights Reserved
# As part of the installation process, you will be asked
# to accept the terms of this Agreement. This Agreement is
# a legal contract, which specifies the terms of the license
# and warranty limitation between you and DCScripts and DCForum97.
# You should carefully read the following terms and conditions before
# installing or using this software.  Unless you have a different license
# agreement obtained from DCScripts, installation or use of this software
# indicates your acceptance of the license and warranty limitation terms
# contained in this Agreement. If you do not agree to the terms of this
# Agreement, promptly delete and destroy all copies of the Software.
#
# Versions of the Software 
# Only one copy of the registered version of DCForum97 may used on one web site.
# 
# License to Redistribute
# Distributing the software and/or documentation with other products
# (commercial or otherwise) or by other than electronic means without
# DCScripts's prior written permission is forbidden.
# All rights to the HKDBoard software and documentation not expressly
# granted under this Agreement are reserved to DCScripts.
#
# Disclaimer of Warranty
# THIS SOFTWARE AND ACCOMPANYING DOCUMENTATION ARE PROVIDED "AS IS" AND
# WITHOUT WARRANTIES AS TO PERFORMANCE OF MERCHANTABILITY OR ANY OTHER
# WARRANTIES WHETHER EXPRESSED OR IMPLIED.   BECAUSE OF THE VARIOUS HARDWARE
# AND SOFTWARE ENVIRONMENTS INTO WHICH HKDBOARD MAY BE USED, NO WARRANTY OF
# FITNESS FOR A PARTICULAR PURPOSE IS OFFERED.  THE USER MUST ASSUME THE
# ENTIRE RISK OF USING THIS PROGRAM.  ANY LIABILITY OF HKDESIGN WILL BE
# LIMITED EXCLUSIVELY TO PRODUCT REPLACEMENT OR REFUND OF PURCHASE PRICE.
# IN NO CASE SHALL DCSCRIPTS BE LIABLE FOR ANY INCIDENTAL, SPECIAL OR
# CONSEQUENTIAL DAMAGES OR LOSS, INCLUDING, WITHOUT LIMITATION, LOST PROFITS
# OR THE INABILITY TO USE EQUIPMENT OR ACCESS DATA, WHETHER SUCH DAMAGES ARE
# BASED UPON A BREACH OF EXPRESS OR IMPLIED WARRANTIES, BREACH OF CONTRACT,
# NEGLIGENCE, STRICT TORT, OR ANY OTHER LEGAL THEORY. THIS IS TRUE EVEN IF
# HKDESIGN IS ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. IN NO CASE WILL
# HKDESIGN'S LIABILITY EXCEED THE AMOUNT OF THE LICENSE FEE ACTUALLY PAID
# BY LICENSEE TO DCSCRIPTS. 
#
# CREDITS:
# The authentication code is the work of Selena Sol and Gunther Berznick
# You can obtain it from Selena Sol's Public Domain Script Archive
# at http://selena.mcp.com/Scripts/ or you can purchase their book
# "Instant Web Scripts with CGI/PERL" -- Great Book!
# cgi-lib.pl was written by Stephen Brenner.
#------------------------------------------------------

# NOTE: You may need to provide full path to each setup files
# Some server require this.

$path = "/vserv/g/gb-dire1/cgi-bin/dcforum97";
$libra = $path . "/Library";

require "$path/dcforum97.setup";
require "$path/dcadmin97.setup";
require "$libra/auth-lib.pl";
require "$libra/cgi-lib.pl";

print &PrintHeader;
&ReadParse;

# Zuweisung der Formularvariablen
$session = $in{"session"};

if ($auth_cgi eq "on")
{
	($session, $username, $group, $firstname, $lastname, $e_mail) = 
		&GetSessionInfo($session, "$dc_admin", *in);
	chop($e_mail) if ($e_mail =~ /\n$/);
}

if ($in{"forum"})
{
	$forum=$in{"forum"};
}

if ($in{"thread_select"})
{
	$thread_select = $in{thread_select};
}

# Hauptmen
if ($in{"action"} eq "list_threads")
{
	&list_threads;
}
elsif ($in{"action"} eq "r_session")
{
	&r_session;
}
elsif ($in{"action"} eq "list_message")
{
	&list_message;
}
elsif ($in{"action"} eq "remove_threads")
{
	&remove_threads;
}
elsif ($in{"action"} eq "remove_messages")
{
	if ($in{"thread_select"})
	{
		$thread_select = $in{"thread_select"};
	}
	&remove_messages;
}
else
{
	&list_forums;
}

#------------------------------------------------
# Subroutine list_forums
#------------------------------------------------
#
# Auflistung der Foren

sub list_forums
{
	$heading = $main_heading;

	$sub_heading = $main_sub_heading;

	$html_output = "";

	$html_output .= $separator_img . "\n";

	$html_output .= qq~
<FORM METHOD=POST ACTION="$adminurl">
<CENTER>
<TABLE BORDER="0">
	<TR>
		<TD COLSPAN="2" ALIGN="left"><B><U>Allgemeine Verwaltung</U></B></TD>
	</TR>   

	<TR>
		<TD COLSPAN="2" ALIGN="left">
			<blockquote>
				<a href="$adminurl?action=r_session&session=$session">Alte Sitzungsdateien entfernen</a>
			</blockquote>
		</TD>
	</TR>   

	<TR>
		<TD COLSPAN="2" ALIGN="left">
			<STRONG><B><U>Forum-Managementfunktionen</U></B></STRONG><br>
			Zuerst auswhlen, ob Zweige oder Beitrge eines Zeiges entfernt werden sollen; dann 
			Auswahl eines Forums.<P>
		</TD>
	</TR>   

	<TR>
		<TD COLSPAN="2" ALIGN="left"><U>Function whlen</U></TD>
	</TR>   

	<TR>
		<TD ALIGN="LEFT" VALIGN="TOP"><INPUT TYPE="RADIO" NAME="remove_type" VALUE="remove_threads"></TD>
		<TD ALIGN="LEFT" VALIGN="TOP">Zweige entfernen</TD>
	</TR>

	<TR>
		<TD ALIGN="LEFT" VALIGN="TOP"><INPUT TYPE="RADIO" NAME="remove_type" VALUE="remove_message"></TD>
		<TD ALIGN="LEFT" VALIGN="TOP">Beitrge aus Zweigen entfernen</TD>   
	</TR>
   
	<TR>
		<TD COLSPAN="2" ALIGN="left"><U>Auswahl eines Forums</U></TD>
	</TR>~;   

	foreach $board (@forums)
	{
		$html_output .= qq~
	<TR>
		<TD ALIGN="LEFT" VALIGN="TOP"><INPUT TYPE="RADIO" NAME="forum" VALUE="$board"></TD>
		<TD ALIGN="LEFT" VALIGN="TOP"><img src="$imgurl/folder.gif">
			<a href="$boardurl?az=list&forum=$board&session=$session">$forum_name{$board}</a>
		</TD>
	</TR>~;

	}


	$html_output .= qq~
</TABLE>
$separator_img
	<INPUT TYPE="HIDDEN" NAME="session" VALUE="$session">
	<INPUT TYPE="HIDDEN" NAME="action" VALUE="list_threads">
	<INPUT TYPE="SUBMIT" VALUE="Formular absenden"> 
	<INPUT TYPE="RESET" VALUE=" Formular lschen ">
</CENTER>
</FORM>~;

	require "$templateurl";

} # Ende der Subroutine list_forums

#------------------------------------------------
# Subroutine list_threads
#------------------------------------------------
#
# Auflistung der Zweige

sub list_threads
{
	open(DATA,"$maindir/$forum/$database") || die $!;
	@rowdata = <DATA>;
	close(DATA);

	$num_messages = @rowdata;
   
	$heading = $lt_heading;
	$sub_heading = $lt_sub_heading;

	$html_output = "";
   
	$html_output .=qq~
$separator_img
<CENTER>
<FORM METHOD=POST ACTION="$adminurl">
<TABLE BORDER="0" CELLPADDING="0" WIDTH="100%">
	<TR>
		<TD BGCOLOR="#99CCFF" ALIGN="CENTER" VALIGN="CENTER"><b>Auswahl</b></TD>
		<TD BGCOLOR="#99CCFF" ALIGN="CENTER"><b>Betrifft</b></TD>
		<TD BGCOLOR="#99CCFF" ALIGN="CENTER"><b>Abgeschickt von</b></TD>
		<TD BGCOLOR="#99CCFF" ALIGN="CENTER" WIDTH="100"><b>Zuletzt modifiziert</b></TD>
		<TD BGCOLOR="#99CCFF" ALIGN="CENTER"><b>Antworten</b></TD>
	</TR>~;

	foreach ($j = 0;$j <= @rowdata -1;$j++)
	{
		$row = $rowdata[$j];
		($num,$date,$localtime,$name,$subject,$replies) = split(/\|/, $row);
		  
		$html_output .=qq~
	<TR>
		<TD BGCOLOR="#DDEEFF" VALIGN="TOP" ALIGN="RIGHT">~;

		if ($in{"remove_type"} eq "remove_threads")
		{	  
			$html_output .=qq~
		<INPUT TYPE="RADIO" NAME="$j" VALUE="selected">~;
		}
		else
		{
			$html_output .=qq~
		<INPUT TYPE="RADIO" NAME="thread_select" VALUE="$num">~;
		}

		$html_output .=qq~
		</TD>
		<TD BGCOLOR="#DDEEFF"><img src="$imgurl/folder.gif">
			<a href="$mainurl/$forum/$num\.$ext"><FONT SIZE=2><b>$subject</b></FONT></a>
		</TD>
		<TD BGCOLOR="#DDEEFF" ALIGN="CENTER"><FONT SIZE=2>$name</FONT></TD>      
		<TD BGCOLOR="#DDEEFF" ALIGN="CENTER" WIDTH="100"><FONT SIZE=2>$localtime $date</FONT></TD>
		<TD BGCOLOR="#DDEEFF" ALIGN="CENTER"><FONT SIZE=2>$replies</FONT></TD>
	</TR>~;
	}
   
	if ($in{"remove_type"} eq "remove_threads")
	{	  
		$html_output .=qq~
	<INPUT TYPE="HIDDEN" NAME="action" VALUE="remove_threads">~;
	}
	else
	{
		$html_output .=qq~
	<INPUT TYPE="HIDDEN" NAME="action" VALUE="list_message">~;
	}

	$html_output .=qq~
</TABLE>
<P>
$separator_img
	<INPUT TYPE="HIDDEN" NAME="session" VALUE="$session">
	<INPUT TYPE="HIDDEN" NAME="forum" VALUE="$forum">
<CENTER>
	<INPUT TYPE="SUBMIT" VALUE="Formular absenden"> 
	<INPUT TYPE="RESET" VALUE=" Formular lschen ">
</CENTER>
</FORM>
</CENTER>~;

	require "$templateurl";

} # Ende der Subroutine list_threads

#------------------------------------------------
# Subroutine list_message
#------------------------------------------------
#
# Auflistung der Beitrge

sub list_message
{
	$heading = $lt_mesg_heading;
	$sub_heading = $lt_mesg_sub_heading;
	$html_output = "";

	open(DATA,"$maindir/$forum/$thread_select\.$ext") || die $!;
	@rowdata = <DATA>;
	close(DATA);

	$print_flag = "off";
   
	$html_output .=qq~
<FORM METHOD="POST" ACTION="$adminurl">~;

	foreach $data (@rowdata)
	{
		if ($data =~ /<!-- BEGIN_BODY:(.*) -->/)
		{
			$reply_num = $1;
			if ($reply_num > 0)
			{		 
				$html_output .= qq~
<center>
$separator_img
	<INPUT TYPE="RADIO" NAME="$reply_num" VALUE="selected">
	<B>Ankreuzen, um den folgenden Beitrag zu lschen</B>
</center>~;
				$print_flag = "on";
			}
		}
		elsif ($data =~ /<!-- END_BODY:(.*) -->/)
		{
			$print_flag = "off";
		}
		elsif ($print_flag eq "on")
		{
			if ($data =~ /$separator_img/)
			{
			}
			else
			{
				$html_output .= $data;
			}
		}
		else
		{
		}
	}

	$html_output .=qq~
$separator_img
	<INPUT TYPE="HIDDEN" NAME="session" VALUE="$session">
	<INPUT TYPE="HIDDEN" NAME="forum" VALUE="$forum">
	<INPUT TYPE="HIDDEN" NAME="thread_select" VALUE="$thread_select">
	<INPUT TYPE="HIDDEN" NAME="action" VALUE="remove_messages">
<CENTER>
	<INPUT TYPE="SUBMIT" VALUE="Forumlar absenden"> 
	<INPUT TYPE="RESET" VALUE="Formular lschen">
</CENTER>
</FORM>
	~;

	require "$templateurl";

} # Ende der Subroutine list_message

#------------------------------------------------
# Subroutine remove_threads
#------------------------------------------------
#
# Lschen von Zweigen

sub remove_threads
{
	open(DATA,"$maindir/$forum/$database") || die $!;
	@rowdata = <DATA>;
	close(DATA);

	$num_messages = @rowdata;
   
	$heading = $rt_heading;
	$sub_header = $rt_sub_heading;
   
	$html_output = "";

	foreach ($j = 0;$j <= $num_messages -1;$j++)
	{
		$row = $rowdata[$j];
		($num,$date,$localtime,$name,$subject,$replies) = split(/\|/, $row);

		if ($in{$j} eq "selected")
		{
			push(@num_selected,$j);
			push(@file_selected,$num);
		}
	}

	foreach $num_select (@num_selected)
	{
		splice(@rowdata, $num_select - $offset, 1);
		$offset++;
	}
   
	foreach $file_select (@file_selected)
	{
		$filename = "$maindir/$forum/$file_select\.$ext";
		if (-e $filename)
		{
			unlink("$filename") || push(@NOT_REMOVED,$single);
			push(@FILE_REMOVED,$file_select);
		}
		else
		{
			push(@NO_FILE,$file_select);
		}
	}

	open(DATA,">$maindir/$forum/$database") || die $!;
	print DATA @rowdata;
	close(DATA);

	$html_output .= qq~
<LI><B><U>Gewhlte Dateien</U></B>
	<LI>@file_selected</LI>
</LI>
<LI><B><U>Entfernte Dateien</U></B>
	<LI>@FILE_REMOVED</LI>
</LI>
<LI><B><U>NICHT ENTFERNTE Dateien</U></B>
	<LI>@NOT_REMOVED</LI>
</LI>
<LI><B><U>NICHT GEFUNDENE Dateien</U></B>
	<LI>@NO_FILE</LI>
</LI>
\&nbsp;
<CENTER>
$separator_img
</CENTER>
<H5 ALIGN="CENTER">
   [ <A HREF="$boardurl?az=list&forum=$forum&session=$session">Zum Foyer der Plauderstube</a>
   | <A HREF="$adminurl?action=list_messages&forum=$forum&session=$session">Zum Verwaltungszentrum</a> ]
</H5>
	~;

	require "$templateurl";
	exit(0);

} # Ende der Subroutine remove_threads

#------------------------------------------------
# Subroutine remove_messages
#------------------------------------------------
#
# Lschen von Beitrgen

sub remove_messages
{
	$heading = "Plauderstubenverwaltung - Statusbericht";
	$sub_header = "Hier die Ergebnisse Ihrer administrativen Aktion:";
   
	$html_output = "";

	open(DATA,"$maindir/$forum/$thread_select\.$ext") || die $!;
	flock(DATA,2);
	@rowdata = <DATA>;
	flock(DATA,8);
	close(DATA);

	foreach ($j = 0;$j <= @rowdata;$j++)
	{
		if ($rowdata[$j] =~ /<!-- HEADER:(.*):(.*) -->/)
		{
			$num_messages = $1;
			$max_file_num = $2;

			foreach ($j = 1;$j <= $max_file_num;$j++)
			{
				if ($in{$j} eq "selected")
				{
					push(@num_selected,$j);
				}
			}
	
			$num_sel = @num_selected;
			$new_num = $num_messages - $num_sel;
			$rowdata[$j] = "<!-- HEADER:$new_num:$max_file_num -->\n";
			last;
		}
	}

	foreach $num_select (@num_selected)
	{
		foreach ($j = 1;$j <= @rowdata;$j++)
		{
			if ($rowdata[$j] =~ /<!-- MESSAGE:$num_select:(.*) -->/)
			{
				splice(@rowdata, $j, 1);
				$j --;
			}
			elsif ($rowdata[$j] =~ /^<!-- BEGIN_BODY:$num_select -->/)
			{
				splice(@rowdata, $j, 1);
				$j --;
				$delete = 1;
			}
			elsif ($rowdata[$j] =~ /^<!-- END_BODY:$num_select -->/)
			{
				splice(@rowdata, $j, 1);
				$j--;
				$delete = 0;
			}
			elsif ($delete == 1)
			{
				splice(@rowdata, $j, 1);
				$j --;
			}
		}
	}

	open(DATA,">$maindir/$forum/$thread_select\.$ext") || die $!;
	print DATA @rowdata;
	close(DATA);

	open(DATA,"$maindir/$forum/$database") || die $!;
	@rowdata = <DATA>;
	close(DATA);

	$num_messages = @rowdata;

	foreach ($j = 0;$j <= $num_messages -1;$j++)
	{
		if ($rowdata[$j] =~ /^$thread_select\|/)
		{
			$row = $rowdata[$j];
			chop($row);
		 
			($num,$date,$localtime,$name,$subject,$replies) = split(/\|/, $row);
			$rowdata[$j] = join("|",$num,$date,$localtime,$name,$subject,$new_num);
			$rowdata[$j] .= "\n";
			next;
		}
	}

	open(DATA,">$maindir/$forum/$database") || die $!;
	print DATA @rowdata;
	close(DATA);


	$html_output .= qq~
<LI><B><U>Gewhlter Zweig</U></B>
	<LI>$thread_select</LI>
</LI>
<LI><B><U>Entfernte Beitrge</U></B>
	<LI>@num_selected</LI>
</LI>
\&nbsp;
<CENTER>
$separator_img
</CENTER>

<H5 ALIGN="CENTER">
	[ <A HREF="$boardurl?az=list&forum=$forum&session=$session">Foyer der Plauderstube</a>
   | <A HREF="$adminurl?action=list_messages&forum=$forum&session=$session">Zum Verwaltungszentrum</a> ]
</H5>
	~;

	require "$templateurl";

} # Ende der Subroutine remove_messages

#------------------------------------------------
# Subroutine r_session
#------------------------------------------------
#
# Entfernen alter Sitzungsdateien

sub r_session
{
	local(@files, $file);

	opendir(SESSIONDIR, "$auth_session_dir");
	@files = grep(!/^\.\.?$/,readdir(SESSIONDIR));
	closedir(SESSIONDIR);

	foreach $file (@files)
	{
		if (-M "$auth_session_dir/$file" > $auth_session_length)
		{
			unlink("$auth_session_dir/$file");
			$html_output .= "$file<br>\n";
		}
	}

	$heading = "Die folgenden alten Sitzungsdateien wurden entfernt";

	$html_output .= qq~
<H5 ALIGN="CENTER">
	[ <A HREF="$boardurl?az=list&forum=$forum&session=$session">Foyer der Plauderstube</a>
	| <A HREF="$adminurl?action=list_messages&forum=$forum&session=$session">Zum Verwaltungszentrum</a> ]
</H5>
	~;

	require "$templateurl";
	exit(0);  

} # Ende der Subroutine r_session
